package dans;

import dans.GUI.GUI;
import dans.util.Log;
import java.lang.reflect.InvocationTargetException;
import javax.swing.SwingUtilities;
import dans.network.NetworkManager;
import dans.network.NetworkState;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Dan
 */
public class DANS {
    private static final int DANS_VERSION = 1;
    private static final String DANS_VERSION_STRING = "0.1beta";
    
    private static GUI gui;
    //private static GUIProxy proxy;
    private static NetworkState state;
    private static NetworkManager manager;
    
    /**
     * @param args the command line arguments
     * @throws java.lang.InterruptedException
     * @throws java.lang.reflect.InvocationTargetException
     */
    public static void main(String[] args) throws InterruptedException, InvocationTargetException {
        Locale.setDefault(new Locale("en", "US"));
        
        String filename = null;
        if(args.length >= 1) {
            filename = args[0];
        }
        
        //Setup initial network state
        Log.debug("Setting up initial network state...");
        if(filename != null) {
            Log.debug("Loading network state from file: " + filename);
            
            //TODO: Load file.
        } else {
            state = NetworkState.createDefaultState();
        }
        Log.debug("Initial network state setup.");
        
        //Setup Network Manager
        Log.debug("Setting up network manager...");
        manager = new NetworkManager(state);
        Log.debug("Network manager setup.");
        
        //Setup GUI
        SwingUtilities.invokeAndWait(() -> {gui = new GUI(state);});
        //proxy = new GUIProxy(gui.getGUIHandler());
        
        ////Setup Log
        //Log.setGUIOutput(proxy);
        
        Log.info("----------------------------------------------------------------");
        Log.info("Dan's Asynchronous Network Simulator (DANS) version " + DANS_VERSION_STRING);
        Log.info("By Daniel Servos (dservos5@uwo.ca)");
        Log.info("----------------------------------------------------------------");
            
        manager.startUp();
        manager.runManager();
    }
    
}
