package dans.GUI;

import dans.util.Log;
import java.awt.Component;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.AbstractCellEditor;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import javax.swing.text.NumberFormatter;
import dans.network.NetworkState;
import dans.network.SettingsConstants;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

/**
 *
 * @author Dan
 * @todo Refactor
 */
public class AlgorithmsCellEditor extends AbstractCellEditor implements TableCellEditor {
    private TableCellEditor editor;
    private GUIHandler hgui;
    private AlgorithmsTableModel model;
    private Icon delete;

    public AlgorithmsCellEditor(GUIHandler hgui, AlgorithmsTableModel model) {
        this.hgui = hgui;
        this.model = model;
        delete = new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Delete16.gif"));
    }

    @Override
    public Object getCellEditorValue() {
        if (editor != null) {
            return editor.getCellEditorValue();
        }

        return null;
    }

    @Override
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        if(column == 0) {
            NumberFormat format = NumberFormat.getInstance();
            NumberFormatter formatter = new NumberFormatter(format);
            formatter.setValueClass(Integer.class);
            formatter.setMaximum(Integer.MAX_VALUE);
            formatter.setMinimum(0);
            formatter.setCommitsOnValidEdit(true);
            formatter.setAllowsInvalid(false);
            editor = new DefaultCellEditor(new JFormattedTextField(formatter));
        } else if(column == 1) {
            String algorithms[] = hgui.getAlgorithms();
            JComboBox box = new JComboBox(algorithms);
            box.addActionListener((ActionEvent e) -> stopCellEditing());
            editor = new DefaultCellEditor(box);
        } else {
            JButton button = new JButton();
            button.setIcon(delete);
            
            button.addActionListener((ActionEvent e) -> {
                stopCellEditing();
                model.removeRow(row);
            });
            
            if(row >= model.getRowCount() - 1) {
                button.setEnabled(false);
            }
            
            return button;
        }          

        return editor.getTableCellEditorComponent(table, value, isSelected, row, column);
    }


}