package dans.GUI;

import com.mxgraph.swing.handler.mxKeyboardHandler;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxGraphActions;
import java.awt.event.KeyEvent;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;
import javax.swing.TransferHandler;
import javax.swing.UIManager;

/**
 *
 * @author Dan
 */

//This class is losesly based on the mxKeyboardHandler class from JGraphX.
public class KeyboardHandler {
    
    public KeyboardHandler(JComponent comp, GUIHandler hgui) {
        SwingUtilities.replaceUIInputMap(comp, JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, getInputMap());
        SwingUtilities.replaceUIActionMap(comp, createActionMap(hgui));
    }
    
    
    private InputMap getInputMap() {
        InputMap map = new InputMap();

        map.put(KeyStroke.getKeyStroke("DELETE"), "delete");
        map.put(KeyStroke.getKeyStroke("control A"), "selectAll");
        map.put(KeyStroke.getKeyStroke("control D"), "selectNone");
        map.put(KeyStroke.getKeyStroke("control X"), "cut");
        map.put(KeyStroke.getKeyStroke("CUT"), "cut");
        map.put(KeyStroke.getKeyStroke("control C"), "copy");
        map.put(KeyStroke.getKeyStroke("COPY"), "copy");
        map.put(KeyStroke.getKeyStroke("control V"), "paste");
        map.put(KeyStroke.getKeyStroke("PASTE"), "paste");
        map.put(KeyStroke.getKeyStroke("control shift EQUALS"), "zoomIn");
        map.put(KeyStroke.getKeyStroke("control MINUS"), "zoomOut");

        map.put(KeyStroke.getKeyStroke("control S"), "save");
        map.put(KeyStroke.getKeyStroke("control shift S"), "saveAs");
        map.put(KeyStroke.getKeyStroke("control N"), "new");
        map.put(KeyStroke.getKeyStroke("control O"), "open");
        map.put(KeyStroke.getKeyStroke("control Z"), "undo");
        map.put(KeyStroke.getKeyStroke("control Y"), "redo");
        map.put(KeyStroke.getKeyStroke("control shift V"), "selectVertices");
        map.put(KeyStroke.getKeyStroke("control shift E"), "selectEdges");

        map.put(KeyStroke.getKeyStroke("control E"), "export");
        map.put(KeyStroke.getKeyStroke("control P"), "print");
        map.put(KeyStroke.getKeyStroke("EQUALS"), "resetzoom");
        map.put(KeyStroke.getKeyStroke("control W"), "exit");
        map.put(KeyStroke.getKeyStroke("F12"), "fullscreen");
        map.put(KeyStroke.getKeyStroke("ESCAPE"), "escape");
        map.put(KeyStroke.getKeyStroke("SPACE"), "playpause");
        map.put(KeyStroke.getKeyStroke("HOME"), "restart");
        map.put(KeyStroke.getKeyStroke("F1"), "selectmode");
        map.put(KeyStroke.getKeyStroke("F2"), "panmode");
        map.put(KeyStroke.getKeyStroke("F3"), "procmode");
        map.put(KeyStroke.getKeyStroke("F4"), "linkmode");
        map.put(KeyStroke.getKeyStroke("F5"), "delmode");
        map.put(KeyStroke.getKeyStroke("F6"), "play");
        map.put(KeyStroke.getKeyStroke("F7"), "pause");
        map.put(KeyStroke.getKeyStroke("F8"), "restart");
        map.put(KeyStroke.getKeyStroke("F9"), "propsproc");
        map.put(KeyStroke.getKeyStroke("F10"), "propsnetowrk");
        map.put(KeyStroke.getKeyStroke("F11"), "propsstats");
        map.put(KeyStroke.getKeyStroke("control alt P"), "toggleprops");
        map.put(KeyStroke.getKeyStroke("control alt L"), "togglelog");
        map.put(KeyStroke.getKeyStroke("control alt S"), "togglestat");
        map.put(KeyStroke.getKeyStroke("control alt T"), "toggletool");
        map.put(KeyStroke.getKeyStroke("control alt M"), "togglemenu");
        map.put(KeyStroke.getKeyStroke("control alt G"), "togglegrid");


        //KeyEvent.VK_SPACE
        
        return map;
    }
    
    private ActionMap createActionMap(GUIHandler hgui) {
        ActionMap map = (ActionMap) UIManager.get("ScrollPane.actionMap");

        map.put("delete", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_DELETE));
        map.put("selectNone", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_SELECT_NONE));
        map.put("selectAll", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_SELECT_ALL));
        map.put("cut", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_CUT));
        map.put("copy", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_COPY));
        map.put("paste", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_PASTE));
        
        map.put("zoomIn", new GUIHandler.ZoomAction(hgui, GUIHandler.ZoomAction.ZOOM_MODE_IN));
        map.put("zoomOut", new GUIHandler.ZoomAction(hgui, GUIHandler.ZoomAction.ZOOM_MODE_OUT));
        map.put("resetzoom", new GUIHandler.ZoomAction(hgui, GUIHandler.ZoomAction.ZOOM_MODE_RESET));

        //map.put("save", new EditorActions.SaveAction(false));
        //map.put("saveAs", new EditorActions.SaveAction(true));
        //map.put("new", new EditorActions.NewAction());
        //map.put("open", new EditorActions.OpenAction());
        
        map.put("undo", new GUIHandler.UndoAction(hgui));
        map.put("redo", new GUIHandler.RedoAction(hgui));
        map.put("selectVertices", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_SELECT_VERT));
        map.put("selectEdges", new GUIHandler.EditingAction(hgui, GUIHandler.EditingAction.EDIT_MODE_SELECT_EDGE));

        map.put("selectmode", new GUIHandler.EditModeAction(hgui, ToolBar.EDIT_MODE_SELECT));
        map.put("procmode", new GUIHandler.EditModeAction(hgui, ToolBar.EDIT_MODE_PROC));
        map.put("linkmode", new GUIHandler.EditModeAction(hgui, ToolBar.EDIT_MODE_LINK));
        map.put("panmode", new GUIHandler.EditModeAction(hgui, ToolBar.EDIT_MODE_PAN));
        map.put("delmode", new GUIHandler.EditModeAction(hgui, ToolBar.EDIT_MODE_DELETE));
        map.put("fullscreen", new GUIHandler.FullScreenAction(hgui));
        
        //TODO: Adding mappings for all the keys/functions in getInputMap().

        return map;
    }
}
