package dans.GUI;

import com.mxgraph.swing.util.mxGraphActions;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.TransferHandler;

/**
 *
 * @author Dan
 */
public class MenuBar extends JMenuBar{
    private GUIHandler hgui;
    
    private JMenu fileMenu;
    private JMenuItem fileMenuNew;
    private JMenuItem fileMenuOpen;
    private JMenuItem fileMenuSave;
    private JMenuItem fileMenuSaveAs;
    private JMenuItem fileMenuExport;
    private JMenuItem fileMenuPrint;
    private JMenuItem fileMenuExit;
    
    private JMenu editMenu;
    private JMenuItem editMenuCopy;
    private JMenuItem editMenuPaste;
    private JMenuItem editMenuCut;
    private JMenuItem editMenuSelect;
    private JMenuItem editMenuUnselect;
    private JMenuItem editMenuUndo;
    private JMenuItem editMenuRedo;
    private JMenuItem editMenuDelete; 
    
    private JMenu viewMenu;
    private JMenuItem viewMenuZoomIn;
    private JMenuItem viewMenuZoomOut;
    private JMenuItem viewMenuZoomReset;
    private JCheckBoxMenuItem viewMenuLog;
    private JCheckBoxMenuItem viewMenuProps;
    private JCheckBoxMenuItem viewMenuTools;
    private JCheckBoxMenuItem viewMenuStatBar;
    private JCheckBoxMenuItem viewMenuMenuBar;
    private JCheckBoxMenuItem viewMenuGrid;
    private JCheckBoxMenuItem viewMenuFullScreen;
    
    private JMenu controlMenu;
    private JMenuItem controlMenuPlay;
    private JMenuItem controlMenuPause;
    private JMenuItem controlMenuRestart;
    
    private JMenu algorithmsMenu;
    
    private JMenu layoutMenu;
    
    private JMenu helpMenu;
    private JMenuItem helpMenuAbout;
    private JMenuItem helpMenuDocs;
    
    public MenuBar(GUIHandler hgui){
        super();
        
        this.hgui = hgui;
        
        //File Menu
        fileMenu = new JMenu("File");
        fileMenu.setMnemonic(KeyEvent.VK_F);
        this.add(fileMenu);
        fileMenuNew = new JMenuItem("New", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/New16.gif")));
        fileMenuNew.setMnemonic(KeyEvent.VK_N);
        fileMenuNew.addActionListener((ActionEvent e) -> hgui.newNetwork());
        fileMenu.add(fileMenuNew);
        fileMenuOpen = new JMenuItem("Open", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Open16.gif")));
        fileMenuOpen.setMnemonic(KeyEvent.VK_O);
        fileMenuOpen.addActionListener((ActionEvent e) -> hgui.load());
        fileMenu.add(fileMenuOpen);
        fileMenu.addSeparator();
        fileMenuSave = new JMenuItem("Save", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Save16.gif")));
        fileMenuSave.setMnemonic(KeyEvent.VK_S);
        fileMenuSave.addActionListener((ActionEvent e) -> hgui.save());
        fileMenu.add(fileMenuSave);
        fileMenuSaveAs = new JMenuItem("Save As...", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/SaveAs16.gif")));
        fileMenuSaveAs.setMnemonic(KeyEvent.VK_A);
        fileMenu.add(fileMenuSaveAs);
        fileMenu.addSeparator();
        fileMenuExport = new JMenuItem("Export Image", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Export16.gif")));
        fileMenuExport.setMnemonic(KeyEvent.VK_T);
        fileMenuExport.addActionListener((ActionEvent e) -> {
            hgui.exportImage();
        });
        fileMenu.add(fileMenuExport);
        fileMenuPrint = new JMenuItem("Print", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Print16.gif")));
        fileMenuPrint.setMnemonic(KeyEvent.VK_P);
        fileMenuPrint.addActionListener((ActionEvent e) -> {
            hgui.print();
        });
        fileMenu.add(fileMenuPrint);
        fileMenu.addSeparator();
        fileMenuExit = new JMenuItem("Exit");
        fileMenuExit.setMnemonic(KeyEvent.VK_X);
        fileMenuExit.addActionListener((ActionEvent e) -> {
            hgui.exit();
        });
        fileMenu.add(fileMenuExit);
        
        //Edit Menu
        editMenu = new JMenu("Edit");
        editMenu.setMnemonic(KeyEvent.VK_E);
        this.add(editMenu);
        editMenuCopy = new JMenuItem("Copy", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Copy16.gif")));
        editMenuCopy.setMnemonic(KeyEvent.VK_C);
        editMenuCopy.addActionListener((ActionEvent e) -> {
            hgui.copy(e);
        });
        editMenu.add(editMenuCopy);
        editMenuCut = new JMenuItem("Cut", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Cut16.gif")));
        editMenuCut.setMnemonic(KeyEvent.VK_T);
        editMenuCut.addActionListener((ActionEvent e) -> {
            hgui.cut(e);
        });
        editMenu.add(editMenuCut);
        editMenuPaste = new JMenuItem("Paste", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Paste16.gif")));
        editMenuPaste.setMnemonic(KeyEvent.VK_P);
        editMenuPaste.addActionListener((ActionEvent e) -> {
            hgui.paste(e);
        });
        editMenu.add(editMenuPaste);
        editMenu.addSeparator();
        editMenuSelect = new JMenuItem("Select All", null);
        editMenuSelect.setMnemonic(KeyEvent.VK_A);
        editMenuSelect.addActionListener((ActionEvent e) -> {
            hgui.selectAll(e);
        });
        editMenu.add(editMenuSelect);
        editMenuUnselect = new JMenuItem("Select None", null);
        editMenuUnselect.setMnemonic(KeyEvent.VK_N);
        editMenuUnselect.addActionListener((ActionEvent e) -> {
            hgui.selectNone(e);
        });
        editMenu.add(editMenuUnselect);
        editMenu.addSeparator();
        editMenuUndo = new JMenuItem("Undo", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Undo16.gif")));
        editMenuUndo.setMnemonic(KeyEvent.VK_U);
        editMenuUndo.addActionListener((ActionEvent e) -> {
            hgui.undo();
        });
        editMenu.add(editMenuUndo);
        editMenuRedo = new JMenuItem("Redo", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Redo16.gif")));
        editMenuRedo.setMnemonic(KeyEvent.VK_O);
        editMenuRedo.addActionListener((ActionEvent e) -> {
            hgui.redo();
        });
        editMenu.add(editMenuRedo);
        editMenu.addSeparator();
        editMenuDelete = new JMenuItem("Delete", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/Delete16.gif")));
        editMenuDelete.setMnemonic(KeyEvent.VK_D);
        editMenuDelete.addActionListener((ActionEvent e) -> {
            hgui.delete(e);
        });
        editMenu.add(editMenuDelete);
        
        
        //View Menu
        viewMenu = new JMenu("View");
        viewMenu.setMnemonic(KeyEvent.VK_V);
        this.add(viewMenu);
        viewMenuZoomIn = new JMenuItem("Zoom In", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/ZoomIn16.gif")));
        viewMenuZoomIn.setMnemonic(KeyEvent.VK_I);
        viewMenuZoomIn.addActionListener((ActionEvent e) -> {
            hgui.zoomIn();
        });
        viewMenu.add(viewMenuZoomIn);
        viewMenuZoomOut = new JMenuItem("Zoom Out", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/ZoomOut16.gif")));
        viewMenuZoomOut.setMnemonic(KeyEvent.VK_O);
        viewMenuZoomOut.addActionListener((ActionEvent e) -> {
            hgui.zoomOut();
        });
        viewMenu.add(viewMenuZoomOut);
        viewMenuZoomReset = new JMenuItem("Reset Zoom");
        viewMenuZoomReset.setMnemonic(KeyEvent.VK_Z);
        viewMenuZoomReset.addActionListener((ActionEvent e) -> {
            hgui.zoomReset();
        });
        viewMenu.add(viewMenuZoomReset);
        viewMenu.addSeparator();
        viewMenuLog = new JCheckBoxMenuItem("Show Log", false);
        viewMenuLog.setMnemonic(KeyEvent.VK_L);
        viewMenuLog.addActionListener((ActionEvent e) -> {
            hgui.showLogWindow(!viewMenuLog.getState());
        });
        viewMenu.add(viewMenuLog);
        viewMenuProps = new JCheckBoxMenuItem("Show Properties", true);
        viewMenuProps.setMnemonic(KeyEvent.VK_P);
        viewMenuProps.addActionListener((ActionEvent e) -> {
            hgui.showPropsTab(!viewMenuProps.getState());
        });
        viewMenu.add(viewMenuProps);
        viewMenuTools = new JCheckBoxMenuItem("Show Tools Bar", true);
        viewMenuTools.setMnemonic(KeyEvent.VK_T);
        viewMenuTools.addActionListener((ActionEvent e) -> {
            hgui.showToolsBar(viewMenuTools.getState());
        });
        viewMenu.add(viewMenuTools);
        viewMenuStatBar = new JCheckBoxMenuItem("Show Status Bar", true);
        viewMenuStatBar.setMnemonic(KeyEvent.VK_S);
        viewMenuStatBar.addActionListener((ActionEvent e) -> {
            hgui.showStatBar(viewMenuStatBar.getState());
        });
        viewMenu.add(viewMenuStatBar);
        viewMenuMenuBar = new JCheckBoxMenuItem("Show Menu Bar", true);
        viewMenuMenuBar.setMnemonic(KeyEvent.VK_M);
        viewMenuMenuBar.addActionListener((ActionEvent e) -> {
            hgui.showMenuBar(viewMenuMenuBar.getState());
        });
        viewMenu.add(viewMenuMenuBar);
        viewMenuGrid = new JCheckBoxMenuItem("Show Grid", false);
        viewMenuGrid.setMnemonic(KeyEvent.VK_G);
        viewMenuGrid.addActionListener((ActionEvent e) -> {
            hgui.showGrid(viewMenuGrid.getState());
        });
        viewMenu.add(viewMenuGrid);
        viewMenu.addSeparator();
        viewMenuFullScreen = new JCheckBoxMenuItem("Full Screen Toggle", false);
        viewMenuFullScreen.setMnemonic(KeyEvent.VK_C);
        viewMenuFullScreen.addActionListener((ActionEvent e) -> {
            hgui.fullscreen(viewMenuFullScreen.getState());
        });
        viewMenu.add(viewMenuFullScreen);
        
        
        //Control Menu
        controlMenu = new JMenu("Control");
        controlMenu.setMnemonic(KeyEvent.VK_R);
        this.add(controlMenu);
        controlMenuPlay = new JMenuItem("Play", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/media/Play16.gif")));
        controlMenuPlay.setMnemonic(KeyEvent.VK_P);
        controlMenuPlay.addActionListener((ActionEvent e) -> hgui.pause());
        controlMenu.add(controlMenuPlay);
        controlMenuPause = new JMenuItem("Pause", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/media/Pause16.gif")));
        controlMenuPause.setMnemonic(KeyEvent.VK_U);
        controlMenuPause.setEnabled(false);
        controlMenuPause.addActionListener((ActionEvent e) -> hgui.pause());
        controlMenu.add(controlMenuPause);
        controlMenuRestart = new JMenuItem("Restart", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/media/StepBack16.gif")));
        controlMenuRestart.setMnemonic(KeyEvent.VK_S);
        controlMenuRestart.setEnabled(false);
        controlMenuRestart.addActionListener((ActionEvent e) -> hgui.reset());
        controlMenu.add(controlMenuRestart);
        
        //TODO: Finish Algorithms Menu
        //algorithmsMenu = new JMenu("Algorithms");
        //this.add(algorithmsMenu);
        
        //TODO: Finish Layout Menu
        //layoutMenu = new JMenu("Layout");
        //this.add(layoutMenu);
        
        //Help Menu
        helpMenu = new JMenu("Help");
        helpMenu.setMnemonic(KeyEvent.VK_H);
        this.add(helpMenu);
        helpMenuAbout = new JMenuItem("About", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/general/About16.gif")));
        helpMenuAbout.setMnemonic(KeyEvent.VK_A);
        helpMenu.add(helpMenuAbout);
        helpMenuDocs = new JMenuItem("Documentation", new ImageIcon(this.getClass().getResource("/toolbarButtonGraphics/development/WebComponent16.gif")));
        helpMenuDocs.setMnemonic(KeyEvent.VK_D);
        helpMenu.add(helpMenuDocs);
        
        
        hgui.register(this);
    }

    public void setLogToggle(boolean b) {
        viewMenuLog.setState(b);
    }

    public void setPropsToggle(boolean b) {
        viewMenuProps.setState(b);
    }

    public void setGridToggle(boolean b) {
        viewMenuGrid.setState(b);
    }
    
    public void setFullScreenToggle(boolean b) {
        viewMenuFullScreen.setState(b);
    }
    
    public boolean getFullScreenToggle() {
        return viewMenuFullScreen.getState();
    }

    void lockUpForPlay() {
        fileMenuNew.setEnabled(false);
        fileMenuOpen.setEnabled(false);
        fileMenuSave.setEnabled(false);
        fileMenuSaveAs.setEnabled(false);
    
        editMenuCopy.setEnabled(false);
        editMenuPaste.setEnabled(false);
        editMenuCut.setEnabled(false);
        editMenuUndo.setEnabled(false);
        editMenuRedo.setEnabled(false);
        editMenuDelete.setEnabled(false);
    
        controlMenuPlay.setEnabled(false);
        controlMenuPause.setEnabled(true);
        controlMenuRestart.setEnabled(false);
    }
    
    void lockUpForPause() {
        controlMenuPlay.setEnabled(true);
        controlMenuPause.setEnabled(false);
        controlMenuRestart.setEnabled(true);
    }
    
    void lockUpForStop() {
        controlMenuPlay.setEnabled(false);
        controlMenuPause.setEnabled(false);
        controlMenuRestart.setEnabled(true);
    }

    void unlockUpForReset() {
        fileMenuNew.setEnabled(true);
        fileMenuOpen.setEnabled(true);
        fileMenuSave.setEnabled(true);
        fileMenuSaveAs.setEnabled(true);
    
        editMenuCopy.setEnabled(true);
        editMenuPaste.setEnabled(true);
        editMenuCut.setEnabled(true);
        editMenuUndo.setEnabled(true);
        editMenuRedo.setEnabled(true);
        editMenuDelete.setEnabled(true);
    
        controlMenuPlay.setEnabled(true);
        controlMenuPause.setEnabled(false);
        controlMenuRestart.setEnabled(false);
    }
}
