
package dans.GUI;

import dans.util.Log;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Dan
 * @todo Add tool tips.
 */
public class NetworkSettingsTableModel extends AbstractTableModel {
    Object[][] rowData;
    public static final String[] columnNames = {"Property Name", "Value"};
    public static final String rowNames[] = {
        "tickSpeed",
        "loggingLevel",
        "defaultPort",
        "defaultSpeedChangeSeed",
        "",
        "defaultProcSpeed",
        "defaultProcSpeedChangeMethod",
        "defaultProcSpeedChangeNormMean",
        "defaultProcSpeedChangeNormSTDV",
        "defaultProcSpeedChangeUniMin",
        "defaultProcSpeedChangeUniMax",
        "defaultProcSpeedChangeMin",
        "defaultProcSpeedChangeMax",
        "defaultProcSpeedChangeConstant",
        "",
        "defaultLinkSpeed",
        "defaultLinkSpeedChangeMethod",
        "defaultLinkSpeedChangeNormMean",
        "defaultLinkSpeedChangeNormSTDV",
        "defaultLinkSpeedChangeUniMin",
        "defaultLinkSpeedChangeUniMax",
        "defaultLinkSpeedChangeMin",
        "defaultLinkSpeedChangeMax",
        "defaultLinkSpeedChangeConstant",
        "",
        "defaultProcCleanFailRate",
        "defaultProcByzantineFailRate",
        "",
        "defaultLinkBandwidth",
        "defaultLinkFailRate",
        "defaultLinkLossRate",
        "defaultLinkErrorRate"
    };
    
    public static final Set<String> typeDouble = new HashSet<>(Arrays.asList(
        new String[] {"defaultProcCleanFailRate", "defaultProcByzantineFailRate", "defaultLinkBandwith", "defaultLinkFailRate", "defaultLinkLossRate", "defaultLinkErrorRate"}
    ));
    public static final Set<String> typeFile = new HashSet<>(Arrays.asList(
        new String[] {"defaultAlgorithm"}
    ));
    public static final Set<String> typeMethod = new HashSet<>(Arrays.asList(
        new String[] {"defaultProcSpeedChangeMethod", "defaultLinkSpeedChangeMethod"}
    ));
    public static final Set<String> typeLogLevel= new HashSet<>(Arrays.asList(
        new String[] {"loggingLevel"}
    ));
    
    public static final Set<String> typeNeg = new HashSet<>(Arrays.asList(
        new String[] {"defaultLinkSpeedChangeNormMean", "defaultLinkSpeedChangeUniMin", "defaultLinkSpeedChangeUniMax", "defaultProcSpeedChangeNormMean", "defaultProcSpeedChangeUniMin", "defaultProcSpeedChangeUniMax", "defaultLinkSpeedChangeConstant", "defaultProcSpeedChangeConstant"}
    ));
    
    private GUIHandler hgui;

    public NetworkSettingsTableModel(GUIHandler hgui, Object[][] data) {
        rowData = data;
        this.hgui = hgui;
    }
    
    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return rowData.length;
    }

    @Override
    public Object getValueAt(int row, int column) {
        return rowData[row][column];
    }

    @Override
    public Class getColumnClass(int column) {
        if(column == 0) {
            return String.class;
        } else {
            return Integer.class;
        }
    }

    @Override
    public void setValueAt(Object value, int row, int column) {        
        if(!rowData[row][column].equals(value)) {
            rowData[row][column] = value;
            fireTableCellUpdated(row, column);
            
            if(value instanceof String) {
                value = ((String)value).replaceAll(",", "");
            }
            
            hgui.networkSettingsUpdate(rowNames[row], value);
        }
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return column == 1 && !NetworkSettingsTableModel.rowNames[row].equals("");
    } 
}
