package dans.GUI;

import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Dan
 * @todo Add tool tips
 */
public class NetworkStatsTableModel extends AbstractTableModel{
    Object[][] rowData;
    public static final String[] columnNames = {"Statistic Name", "Value"};
    public static final String rowNames[] = {
        "Network State",
        "Tick",
        "",
        "Messages Sent",
        "Bytes Sent",
        "Cycles",
        "",
        "Clean Fails",
        "Byzantine Fails",
        "Link Fails",
        "Packets Lost",
        "Link Errors"
        //TODO: Add the following stats.
        /*"",
        "Active Processors",
        "Inactive Processors",
        "Terminated Processors",
        "Active Links",
        "Inactive Links"*/
    };

    public NetworkStatsTableModel(Object[][] data) {
        rowData = data;
    }
    
    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return rowData.length;
    }

    @Override
    public Object getValueAt(int row, int column) {
        return rowData[row][column];
    }

    @Override
    public Class getColumnClass(int column) {
        if(column == 0) {
            return String.class;
        } else {
            return Integer.class;
        }
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        rowData[row][column] = value;
        fireTableCellUpdated(row, column);
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return false;
    } 
}
