package dans.GUI;

import java.util.Arrays;
import javax.swing.table.AbstractTableModel;
import dans.network.NetworkObject;
import dans.network.NetworkObjectListener;

/**
 *
 * @author Dan
 * @todo Add tool tips.
 */
public class ObjectStatsTableModel extends AbstractTableModel implements NetworkObjectListener  {
    Object[][] rowData;
    public static final String[] columnNames = {"Statistic Name", "Value"};
    public String rowNames[];
    private NetworkObject no;

    public ObjectStatsTableModel(NetworkObject no, String rows[]) {
        rowData = no.dumpStats(rows);
        rowNames = rows;
        no.addListener(this, true);
        this.no = no;
    }
    
    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return rowData.length;
    }

    @Override
    public Object getValueAt(int row, int column) {
        return rowData[row][column];
    }

    @Override
    public Class getColumnClass(int column) {
        if(column == 0) {
            return String.class;
        } else {
            return Integer.class;
        }
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        rowData[row][column] = value;
        fireTableCellUpdated(row, column);
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return false;
    } 

    @Override
    public void networkObjectChange(NetworkObject object, Object newvalue, int eventID, Object caller) {
        if(eventID == NetworkObject.EVENT_STATS_UPDATE) {
            String name = (String)((Object[])newvalue)[0];
            int row = Arrays.asList(rowNames).indexOf(name);
            if(row >= 0) {
                setValueAt(((Object[])newvalue)[1], row, 1);
            }
        } else if(eventID == NetworkObject.EVENT_STATUS_UPDATE) {
            int row = Arrays.asList(rowNames).indexOf("Status");
            if(row >= 0) {
                setValueAt(object.getStatus(), row, 1);
            }
        }
    }
    
    public void removeListener() {
        no.removeListener(this);
    }
}
