/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dans.GUI;

import com.mxgraph.swing.mxGraphComponent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;
import java.awt.image.ImageProducer;
import java.awt.image.RGBImageFilter;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

/**
 *
 * @author Dan
 */
public class PrintOut implements Printable {
    private mxGraphComponent graphComp;
    
    PrintOut(mxGraphComponent graphComp) {
        this.graphComp = graphComp;
    }

    @Override
    public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
        if (pageIndex > 0) {
            return NO_SUCH_PAGE;
        }
        
        BufferedImage image = new BufferedImage(graphComp.getWidth(), graphComp.getHeight(), BufferedImage.TYPE_INT_RGB);
        Graphics g = image.createGraphics();
        g.fillRect(0, 0, image.getWidth(), image.getHeight());
        graphComp.print(g);
        
        //Make background transparent.
        //Based on code from http://stackoverflow.com/questions/665406/how-to-make-a-color-transparent-in-a-bufferedimage-and-save-as-png
        ImageFilter filter = new RGBImageFilter() {
            public int markerRGB = graphComp.getBackground().getRGB() | 0xFF000000;
            @Override
            public final int filterRGB(int x, int y, int rgb) {
                    if ((rgb | 0xFF000000) == markerRGB) {
                            return 0x00FFFFFF & rgb;
                    } else {
                            return rgb;
                    }
            }
        };
        ImageProducer ip = new FilteredImageSource(image.getSource(), filter);
        Image im = Toolkit.getDefaultToolkit().createImage(ip);
        image = new BufferedImage(im.getWidth(null), im.getHeight(null), BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2 = image.createGraphics();
        g2.drawImage(im, 0, 0, null);
        g2.dispose();
        image = image.getSubimage(2, 2, image.getWidth()-4, image.getHeight()-4); //crop out borders
        //End code to make transparent.
        
        graphics.drawImage(image, 0, 0, null);
 
        return PAGE_EXISTS;
    }
    
}
