package dans.GUI;

import dans.util.Log;
import java.awt.Component;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.AbstractCellEditor;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import javax.swing.text.NumberFormatter;
import dans.network.NetworkState;
import dans.network.SettingsConstants;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

/**
 *
 * @author Dan
 * @todo Refactor this and LinkSettingsCellEditor into one class.
 */
public class ProcessorSettingsCellEditor extends AbstractCellEditor implements TableCellEditor {
    private TableCellEditor editor;

    public ProcessorSettingsCellEditor(){

    }

    @Override
    public Object getCellEditorValue() {
        if (editor != null) {
            return editor.getCellEditorValue();
        }

        return null;
    }

    @Override
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        String rowName = ProcessorSettingsTableModel.rowNames[row];
        
        if(ProcessorSettingsTableModel.typeMethod.contains(rowName)) {
            JComboBox box = new JComboBox(SettingsConstants.CHANGE_METHODS);
            ProcessorSettingsCellEditor self = this;
            box.addActionListener(new ActionListener () {
                @Override
                public void actionPerformed(ActionEvent e) {
                    self.stopCellEditing();
                }
                  
            });
            editor = new DefaultCellEditor(box);
        } else if(ProcessorSettingsTableModel.typeDouble.contains(rowName)) {
            NumberFormat format = DecimalFormat.getInstance();
            format.setMinimumFractionDigits(1);
            format.setMaximumFractionDigits(2);
            format.setMinimumIntegerDigits(1);
            NumberFormatter formatter = new NumberFormatter(format);
            formatter.setValueClass(Double.class);
            formatter.setMaximum(Double.MAX_VALUE);
            formatter.setMinimum(0.0d);
            formatter.setCommitsOnValidEdit(false);
            formatter.setAllowsInvalid(false);
            editor = new DefaultCellEditor(new JFormattedTextField(formatter));
        } else {
            NumberFormat format = NumberFormat.getInstance();
            NumberFormatter formatter = new NumberFormatter(format);
            formatter.setValueClass(Integer.class);
            formatter.setMaximum(Integer.MAX_VALUE);
            if(ProcessorSettingsTableModel.typeNeg.contains(rowName)) {
                formatter.setMinimum(Integer.MIN_VALUE);
            } else {
                formatter.setMinimum(0);
            }
            formatter.setCommitsOnValidEdit(true);
            formatter.setAllowsInvalid(false);
            editor = new DefaultCellEditor(new JFormattedTextField(formatter));
        }            

        return editor.getTableCellEditorComponent(table, value, isSelected, row, column);
    }


}