package dans.GUI;

import java.awt.FontMetrics;
import java.awt.Graphics;
import java.nio.CharBuffer;
import javax.swing.BorderFactory;
import javax.swing.JLabel;

/**
 *
 * @author Dan
 */
public class StatusBar extends JLabel{
    private int x = 0;
    private int y = 0;
    private int tick = 0;
    private String msg = "";
    
    public StatusBar() {
        super();
        this.setBorder(BorderFactory.createEmptyBorder(2, 4, 2, 4));
        //resetText();
    }
    
    public void resetText() {
        if(this.isVisible() && this.getWidth() > 0) {
            String locS = "LOC: " + x + ", " + y;
            String tickS = "Tick: " + tick; 

            FontMetrics metrics = this.getFontMetrics(this.getFont());
            int spaceWidth = metrics.charWidth(' ');
            int locWidth = metrics.stringWidth(locS);
            int tickWidth = metrics.stringWidth(tickS);
            int msgWidth = metrics.stringWidth(msg);
            int numSpaces = ((this.getWidth() - locWidth - tickWidth - msgWidth - 10)/2)/spaceWidth;

            String spaces = CharBuffer.allocate(numSpaces).toString().replace('\0', ' ');
            this.setText(locS + spaces + msg + spaces + tickS);
        }
    }
    
    public void setMsg(String msg) {
        this.msg = msg;
        resetText();
    }
    
    public void setTick(int tick) {
        this.tick = tick;
        resetText();
    }
    
    public void setLoc(int x, int y) {
        this.x = x;
        this.y = y;
        resetText();
    }
}
