package dans.GUI;

import com.mxgraph.util.mxConstants;
import com.mxgraph.view.mxGraph;
import com.mxgraph.view.mxStylesheet;
import java.util.Hashtable;

/**
 *
 * @author Dan
 */
public class StyleSheet extends mxStylesheet {
    public StyleSheet() {
        super();
        buildstyles(null);
    }
    
    public StyleSheet(mxGraph graph) {
        super();
        buildstyles(graph);
    }

    private void buildstyles(mxGraph graph) {
        if(graph != null) {
            this.setStyles(graph.getStylesheet().getStyles());
        }
        
        Hashtable<String, Object> style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_ELLIPSE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "lightgreen");
        this.putCellStyle("running", style);
        
        style = (Hashtable<String, Object>) this.getDefaultVertexStyle();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_ELLIPSE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "lightgreen");
        this.setDefaultVertexStyle(style);
        

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_ELLIPSE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "#CCFFCC");
        style.put(mxConstants.STYLE_STROKEWIDTH, 3);
        style.put(mxConstants.STYLE_STROKECOLOR, "#00FF00");
        this.putCellStyle("runninghighlight", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_ELLIPSE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "red");
        this.putCellStyle("stopped", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_ELLIPSE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "orange");
        this.putCellStyle("failed", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RECTANGLE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "lightgreen");
        this.putCellStyle("runningroot", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RECTANGLE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "lightgreen");
        style.put(mxConstants.STYLE_STROKEWIDTH, 3);
        style.put(mxConstants.STYLE_STROKECOLOR, "#00FF00");
        this.putCellStyle("runningroothighlight", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RECTANGLE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "red");
        this.putCellStyle("stoppedroot", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RECTANGLE);
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 15);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        style.put(mxConstants.STYLE_FILLCOLOR, "orange");
        this.putCellStyle("failedroot", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RECTANGLE);
        style.put(mxConstants.STYLE_OPACITY, 0);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        style.put(mxConstants.STYLE_FONTSIZE, 10);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_MOVABLE, false);
        style.put(mxConstants.STYLE_AUTOSIZE, false);
        this.putCellStyle("child", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_STROKEWIDTH, 5);
        style.put(mxConstants.STYLE_FONTCOLOR, "red");
        style.put(mxConstants.STYLE_FONTSIZE, 17);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_LEFT);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_STROKECOLOR, "green");
        this.putCellStyle("edgeon", style);  
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_STROKEWIDTH, 5);
        style.put(mxConstants.STYLE_FONTCOLOR, "red");
        style.put(mxConstants.STYLE_FONTSIZE, 17);
        style.put(mxConstants.STYLE_FONTSTYLE, mxConstants.FONT_BOLD);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_LEFT);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_STROKEWIDTH, 7);
        style.put(mxConstants.STYLE_STROKECOLOR, "#00FF00");
        this.putCellStyle("edgeonhighlight", style);

        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_STROKEWIDTH, 5);
        style.put(mxConstants.STYLE_STROKECOLOR, "lightblue");
        style.put(mxConstants.STYLE_FOLDABLE, false);
        this.putCellStyle("edgeoff", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_STROKEWIDTH, 5);
        style.put(mxConstants.STYLE_STROKECOLOR, "orange");
        style.put(mxConstants.STYLE_FOLDABLE, false);
        this.putCellStyle("failededge", style);
        
        style = (Hashtable<String, Object>) this.getDefaultEdgeStyle();
        style.put(mxConstants.STYLE_OPACITY, 100);
        style.put(mxConstants.STYLE_STROKEWIDTH, 5);
        style.put(mxConstants.STYLE_STROKECOLOR, "lightblue");
        style.put(mxConstants.STYLE_FOLDABLE, false);
        this.setDefaultEdgeStyle(style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_LEFT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_TOP);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_BENDABLE, false);
        style.put(mxConstants.STYLE_CLONEABLE, false);
        style.put(mxConstants.STYLE_DELETABLE, false);
        style.put(mxConstants.STYLE_EDITABLE, false);
        style.put(mxConstants.STYLE_MOVABLE, false);
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_FONTCOLOR, "darkblue");
        this.putCellStyle("sourcelabel", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_RIGHT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_BOTTOM);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_BENDABLE, false);
        style.put(mxConstants.STYLE_CLONEABLE, false);
        style.put(mxConstants.STYLE_DELETABLE, false);
        style.put(mxConstants.STYLE_EDITABLE, false);
        style.put(mxConstants.STYLE_MOVABLE, false);
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_FONTCOLOR, "green");
        this.putCellStyle("targetlabel", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_LEFT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_TOP);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_BENDABLE, false);
        style.put(mxConstants.STYLE_CLONEABLE, false);
        style.put(mxConstants.STYLE_DELETABLE, false);
        style.put(mxConstants.STYLE_EDITABLE, false);
        style.put(mxConstants.STYLE_MOVABLE, false);
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_FONTCOLOR, "darkred");
        style.put(mxConstants.STYLE_FONTSIZE, 10);
        this.putCellStyle("toplabel", style);
        
        style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_RIGHT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_BOTTOM);
        style.put(mxConstants.STYLE_FOLDABLE, false);
        style.put(mxConstants.STYLE_BENDABLE, false);
        style.put(mxConstants.STYLE_CLONEABLE, false);
        style.put(mxConstants.STYLE_DELETABLE, false);
        style.put(mxConstants.STYLE_EDITABLE, false);
        style.put(mxConstants.STYLE_MOVABLE, false);
        style.put(mxConstants.STYLE_RESIZABLE, false);
        style.put(mxConstants.STYLE_FONTCOLOR, "darkred");
        style.put(mxConstants.STYLE_FONTSIZE, 10);
        this.putCellStyle("bottomlabel", style);
    }
}
