package dans.GUI;

import com.mxgraph.model.mxGeometry;
import com.mxgraph.model.mxICell;
import com.mxgraph.swing.handler.mxConnectPreview;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxRectangle;
import com.mxgraph.view.mxCellState;
import com.mxgraph.view.mxGraph;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import dans.network.Link;
import dans.network.NetworkState;

/**
 *
 * @author Dan
 */

//Based on code from mxConnectPreview in JGraphX lib.
public class mxLinkPreview extends mxConnectPreview {
    private NetworkState state;
    
    mxLinkPreview(mxGraphComponent graphComp, NetworkState state) {
        super(graphComp);
        this.state = state;
    }
  
    @Override
    protected Object createCell(mxCellState startState, String style) {
        mxNetwork graph = (mxNetwork)graphComponent.getGraph();
        mxProcessor proc = (mxProcessor)startState.getCell();

        Link l = new Link("" + mxLink.getLastID(), ((mxProcessor)proc).getProcessor(), null);
        l.setDefaultSettings(state);
        l.setDefaultStats(state);

        mxLink cell = graph.createLink(l, style);
        proc.insertEdge(cell, true);

        return cell;
    }
    
    /*
    @Override
    public Object stop(boolean commit) {
        return stop(commit, null);
    }
    
    @Override
    public Object stop(boolean commit, MouseEvent e) {
        Object o = super.stop(commit, e);

        
        return o;
    }*/
    
    @Override
    public void update(MouseEvent e, mxCellState targetState, double x, double y) {
        mxGraph graph = graphComponent.getGraph();
        mxLink cell = (mxLink) previewState.getCell();

        mxRectangle dirty = graphComponent.getGraph().getPaintBounds(new Object[] { previewState.getCell() });

        if (cell.getTerminal(false) != null) {
            cell.getTerminal(false).removeEdge(cell, false);
            //cell.getLink().setTarget(null, this);
        }

        if (targetState != null && targetState.getCell() instanceof mxProcessor) {
            mxProcessor proc = (mxProcessor) targetState.getCell();
            //cell.getLink().setTarget(proc.getProcessor(), this);
            proc.insertEdge(cell, false);
        }

        mxGeometry geo = graph.getCellGeometry(previewState.getCell());

        geo.setTerminalPoint(startPoint, true);
        geo.setTerminalPoint(transformScreenPoint(x, y), false);

        revalidate(previewState);
        fireEvent(new mxEventObject(mxEvent.CONTINUE, "event", e, "x", x, "y", y));

        Rectangle tmp = getDirtyRect(dirty);

        if (tmp != null) {
            graphComponent.getGraphControl().repaint(tmp);
        }
        else {
            graphComponent.getGraphControl().repaint();
        }
    }
    
}
