package dans.algorithm.examples;

import dans.algorithm.Algorithm;
import dans.algorithm.Message;

/**
 * This algorithm simply sends the message "Hello" plus the value of a counter
 * equal to the number of cycles the algorithm has completed to all of its
 * neighbors.
 * 
 * @author Daniel Servos
 * @version 0.1beta
 */
public class HelloWorld extends Algorithm {
    private static final int loops = Integer.MAX_VALUE;
    private int cycle = 0;
    
    public HelloWorld() {
        //print("Hello World!");
    }

    @Override
    public Object algorithm() {
        while(doMainLoop()) {
            String ids[] = getNeighbors();
            for(String id : ids) {
                Message m = new Message(id, "Hello " + cycle);
                send(m);
            }
            
            Message m;
            while((m = this.receive()) != null) {
                print("Got message from " + m.from() + " with text \"" + m.message() + "\"");
                display(m.message());
            }

            if(++cycle > loops) {
                terminate();
            }
        }
        
        return 0;
    }
}
