package dans.algorithm.examples;

import dans.algorithm.Algorithm;
import dans.algorithm.Message;

/**
 * This algorithm elects a leader in a directional ring network. It is assumed
 * that a directional ring network of at least two processors exists and that
 * there is only one link from each processor. It is required that all processors
 * in the network have numerical IDs.
 * 
 * @author Daniel Servos
 * @version 0.1beta
 */
public class LeaderElection extends Algorithm {

    @Override
    public Object algorithm() {
        int id = Integer.parseInt(getID());
        String msg = getID();
        String status = "UNKOWN";
        String neighbors[] = getNeighbors();
        int leader = -1;
        
        while(doMainLoop()) {
            if (msg != null) {
                send(neighbors[0], msg);
                
                if(msg.startsWith("END")) {
                    return leader;
                }
            }
            
            msg = null;
            
            Message m = receive(false);
            if(m != null) {
                if(m.message().startsWith("END")) {
                    leader = Integer.parseInt(m.message().split(",")[1]);  
                    
                    if(neighbors[0].equals(leader+"")) {
                        return leader;
                    } else {
                        msg = m.message();
                    }
                } else {
                    int i = m.toInt();
                    if(i > id) {
                        status = "NOT LEADER";
                        msg = m.message();
                    } else if(id > i) {
                        msg = null;
                    } else {
                        leader = Integer.parseInt(getID());
                        status = "LEADER";
                        msg = "END," + leader;
                    }
                }
            }
            
            display(status);
        }
        
        return leader;
    }
    
}
