package dans.network;

import dans.algorithm.Message;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Dan
 */
public class BackEndMessage {
    public String fromID = null;
    public String toID = null;
    public String linkID = null;
    public String msg = null;
    public int sentTick = -1;
    public int receivedTick = -1;
    public int port = -1;
    public int senderPort = -1;
    
    public BackEndMessage(){}
    
    public BackEndMessage(Message m) {
        fromID = m.from();
        toID = m.to();
        linkID = m.link();
        msg = m.message();
        sentTick = m.sent();
        receivedTick = m.received();
        port = m.port();
        senderPort = m.senderPort();
    }
    
    public BackEndMessage(BackEndMessage m) {
        fromID = m.fromID;
        toID = m.toID;
        linkID = m.linkID;
        msg = m.msg;
        sentTick = m.sentTick;
        receivedTick = m.receivedTick;
        port = m.port;
        senderPort = m.senderPort;
    }
    
    public Message makeMessage() {
        Message m = new Message(toID, msg);
        try {
            Method method = Message.class.getDeclaredMethod("setUp", String.class, String.class, String.class, String.class, Integer.class, Integer.class, Integer.class, Integer.class);
            method.setAccessible(true);
            method.invoke(m, fromID, toID, linkID, msg, sentTick, receivedTick, port, senderPort);
        } catch (NoSuchMethodException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | SecurityException ex) {
            return null;
        }
        
        return m;
    }
    
    @Override
    public String toString() {
        return msg;
    }
    
    public int size() {
        return msg.length();
    }
}
