package dans.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 *
 * @author Dan
 */
public final class Utils {
    private Utils(){};
    
    public static double round(double val, int digits) {
        int x = (int)Math.pow(10, digits);
        return (double)Math.round(val * x) / x;
    }
    
    public static int makeInt(Object o) {
        if(o instanceof String) {
            ((String)o).replaceAll(",", "");
            ((String)o).replaceAll("$", "");
            return Integer.parseInt((String)o);
        } else if (o instanceof Integer) {
            return (Integer)o;
        }
        
        return (int)o;
    }
    
    public static long makeLong(Object o) {
        if(o instanceof String) {
            ((String)o).replaceAll(",", "");
            ((String)o).replaceAll("$", "");
            return Long.parseLong((String)o);
        } else if (o instanceof Long) {
            return (Long)o;
        }
        
        return (long)o;
    }
    
    public static double makeDouble(Object o) {
        if(o instanceof String) {
            ((String)o).replaceAll(",", "");
            ((String)o).replaceAll("$", "");
            return Double.parseDouble((String)o);
        } else if (o instanceof Double) {
            return (Double)o;
        }
        
        return (double)o;
    }
    
    //Based on code form http://stackoverflow.com/questions/21752771/java-clone-deep-copy-hashmap
    public static <T extends Serializable> T deepClone(T o) {
        ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
        ObjectOutputStream out;
        ObjectInputStream in;
        try {
            out = new ObjectOutputStream(byteOut);
            out.writeObject(o);
            out.flush();
            in = new ObjectInputStream(new ByteArrayInputStream(byteOut.toByteArray()));
            return (T) o.getClass().cast(in.readObject());
        } catch (IOException | ClassNotFoundException ex) {
            Log.error("Error deep cloning object.", ex);
        }

        return null;
    }
}
